// Copyright 2022 ESRI
//
// All rights reserved under the copyright laws of the United States
// and applicable international laws, treaties, and conventions.
//
// You may freely redistribute and use this sample code, with or
// without modification, provided you include the original copyright
// notice and use restrictions.
//
// See the Sample code usage restrictions document for further information.
//

#ifndef DISPLAY_A_MAP_H
#define DISPLAY_A_MAP_H

namespace Esri
{

namespace ArcGISRuntime
{
class Map;
class MapQuickView;

class FeatureLayer;
class ServiceFeatureTable;

}
}
#include <QObject>

Q_MOC_INCLUDE("MapQuickView.h")

class Display_a_map : public QObject
{
    Q_OBJECT
    Q_PROPERTY(Esri::ArcGISRuntime::MapQuickView* mapView READ mapView WRITE setMapView NOTIFY mapViewChanged)

public:
    explicit Display_a_map(QObject* parent = nullptr);
    ~Display_a_map() override;

    Q_INVOKABLE void runQuery(const QString& expression);

signals:
    void mapViewChanged();

private:
    Esri::ArcGISRuntime::MapQuickView* mapView() const;
    void setMapView(Esri::ArcGISRuntime::MapQuickView* mapView);
    void setupViewpoint();

    void addFeatureLayer();
    Esri::ArcGISRuntime::FeatureLayer* m_featureLayer = nullptr;
    Esri::ArcGISRuntime::ServiceFeatureTable* m_featureTable = nullptr;

    Esri::ArcGISRuntime::Map* m_map = nullptr;
    Esri::ArcGISRuntime::MapQuickView* m_mapView = nullptr;
};

#endif // DISPLAY_A_MAP_H

