// Copyright 2022 ESRI
//
// All rights reserved under the copyright laws of the United States
// and applicable international laws, treaties, and conventions.
//
// You may freely redistribute and use this sample code, with or
// without modification, provided you include the original copyright
// notice and use restrictions.
//
// See the Sample code usage restrictions document for further information.
//

import QtQuick
import QtQuick.Controls
import Esri.Display_a_map

Item {

    // Create MapQuickView here, and create its Map etc., in C++ code
    MapView {
        id: view
        anchors.fill: parent
        // set focus to enable keyboard navigation
        focus: true
    }

    // Declare the C++ instance that creates the map etc., and supply the view.
    Display_a_map {
        id: model
        mapView: view
    }

    ComboBox {
        id: queryComboBox
        anchors {
            left: parent.left
            top: parent.top
            margins: 15
        }

        property int bestWidth: implicitWidth
        width: bestWidth + leftPadding + rightPadding
        model: ["Choose a SQL where clause",
            "UseType = 'Government'",
            "UseType = 'Residential'",
            "UseType = 'Irrigated Farm'",
            "TaxRateArea = 10853",
            "TaxRateArea = 10860",
            "Roll_LandValue > 1000000",
            "Roll_LandValue < 1000000"]

        onCurrentTextChanged: {
            model.runQuery(queryComboBox.currentText)
        }
    }

}

